'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (babel) {
  var doPlugin = (0, _babelPluginTransformDoExpressions2.default)();
  var t = babel.types;

  function isReactPugReference(node) {
    // TODO: do this better
    return t.isIdentifier(node, { name: 'pug' });
  }
  var helpers = {};
  return {
    visitor: {
      Program: function Program(path) {
        helpers.flatten = path.scope.generateUidIdentifier('pugFlatten');
        var flattenInnerHelper = path.scope.generateUidIdentifier('pugFlattenInnerHelper');
        var Array_isArray = t.memberExpression(t.identifier('Array'), t.identifier('isArray'));
        path.unshiftContainer("body", [t.functionDeclaration(flattenInnerHelper, [t.identifier('arr'), t.identifier('val')], t.blockStatement([t.returnStatement(t.callExpression(t.memberExpression(t.identifier('arr'), t.identifier('concat')), [t.conditionalExpression(t.callExpression(Array_isArray, [t.identifier('val')]), t.callExpression(helpers.flatten, [t.identifier('val')]), t.identifier('val'))]))])), t.functionDeclaration(helpers.flatten, [t.identifier('arr')], t.blockStatement([t.returnStatement(t.callExpression(t.memberExpression(t.identifier('arr'), t.identifier('reduce')), [flattenInnerHelper, t.arrayExpression([])]))]))]);
      },
      TaggedTemplateExpression: function TaggedTemplateExpression(path) {
        var _this = this;

        if (isReactPugReference(path.node.tag) && path.node.quasi.expressions.length === 0 && path.node.quasi.quasis.length === 1) {
          (function () {
            var src = path.node.quasi.quasis[0].value.raw;
            var minIndent = src.split('\n').reduce(function (minIndent, line) {
              return line.trim().length ? Math.min(/^ */.exec(line)[0].length, minIndent) : minIndent;
            }, Infinity);
            src = src.split('\n').map(function (line) {
              return line.substr(minIndent);
            }).join('\n');
            var ast = (0, _parsePug2.default)(src);
            var transformed = (0, _codeGen2.default)({
              babel: babel,
              parse: function parse(str) {
                return (0, _babylon.parse)(str, _this.file.parserOpts);
              },
              helpers: helpers,
              ast: ast,
              path: path
            }).map(function (node) {
              if (t.isJSXExpressionContainer(node)) {
                return node.expression;
              } else {
                return node;
              }
            });

            if (transformed.length === 1) {
              path.replaceWith(transformed[0]);
            } else {
              path.replaceWith(t.arrayExpression(transformed));
            }
            path.traverse(doPlugin.visitor);
          })();
        }
      }
    }
  };
};

var _babylon = require('babylon');

var _babelPluginTransformDoExpressions = require('babel-plugin-transform-do-expressions');

var _babelPluginTransformDoExpressions2 = _interopRequireDefault(_babelPluginTransformDoExpressions);

var _parsePug = require('./parse-pug');

var _parsePug2 = _interopRequireDefault(_parsePug);

var _codeGen = require('./code-gen');

var _codeGen2 = _interopRequireDefault(_codeGen);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }